/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vista;

import clase.Conexion;
import clase.Controlador;
import java.awt.Image;
import java.io.File;
import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Aldo
 */
public class bdimagen extends javax.swing.JFrame {

    Controlador control = new Controlador();
    //String ruta = null;
    DefaultTableModel modelo;
    String idUsuario = "";

    /**
     * Creates new form bdimagen
     */
    public bdimagen() {
        initComponents();
        TituloTabla();
        llenarTabla();
        LimpiarCampos();
        EstadoCampos(false);
        Botones(false);

    }

    public void EstadoCampos(boolean estado) {
        jTextFieldNombreUsuario.setEnabled(estado);
    }

    public void Botones(boolean estado) {
        jButtonCancelar.setEnabled(estado);
        jButtonModificar.setEnabled(estado);
        jButtonAbrir.setEnabled(estado);
    }

    public void LimpiarCampos() {
        jTextFieldNombreUsuario.setText("");
        jLabelRuta.setText("");
    }

    public void TituloTabla() {
        String[] titulos = {"ID", "USUARIO", "FOTO"};
        modelo = new DefaultTableModel(null, titulos);
        modelo.setColumnIdentifiers(titulos);
        jTableListado.setModel(modelo);
    }

    public void llenarTabla() {
        control.MostrarEnTabla("select * from usuario", jTableListado, modelo, 3);
    }

    public void Insertar() {
        FileInputStream archivofoto;
        try {
            Connection connection = Conexion.getInstance().getConnection();
            PreparedStatement statement = connection.prepareCall("insert into usuario (nombre,foto) values(?,?)");
            statement.setString(1, jTextFieldNombreUsuario.getText());
            // pero para ello necesitamos conocer la ruta de la imagen
            archivofoto = new FileInputStream(jLabelRuta.getText());
            //SetBinaryStream permite almacenar cantidad de bytes en la base de datos
            statement.setBinaryStream(2, archivofoto);
            statement.executeUpdate();
            connection.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al insertar");
        }
    }

    public void Modificar() {
        // String idUsuario = control.CapturarId("select id_usuario from usuario where nombre='", jTextFieldNombreUsuario.getText());
        FileInputStream archivofoto;
        try {
            Connection connection = Conexion.getInstance().getConnection();
            PreparedStatement statement = connection.prepareCall("update usuario set nombre=?, foto=? where id_usuario=?");
            statement.setString(1, jTextFieldNombreUsuario.getText());
            // pero para ello necesitamos conocer la ruta de la imagen
            archivofoto = new FileInputStream(jLabelRuta.getText());
            //SetBinaryStream permite almacenar cantidad de bytes en la base de datos
            statement.setBinaryStream(2, archivofoto);
            statement.setString(3, idUsuario);
            statement.executeUpdate();
            connection.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al modificar");
        }
    }

    public void AsignarCampos() {
        try {
            idUsuario = modelo.getValueAt(jTableListado.getSelectedRow(), 0).toString();
            jTextFieldNombreUsuario.setText(modelo.getValueAt(jTableListado.getSelectedRow(), 1).toString());
            String img = modelo.getValueAt(jTableListado.getSelectedRow(), 2).toString();
            jLabelRuta.setText(img);
            Image foto = getToolkit().getImage(img);
            foto = foto.getScaledInstance(110, 110, 1);
            jLabelmostrarfoto.setIcon(new ImageIcon(foto));
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al asignar campos");
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItemModificar = new javax.swing.JMenuItem();
        jMenuItemEliminar = new javax.swing.JMenuItem();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableListado = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldNombreUsuario = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jButtonAbrir = new javax.swing.JButton();
        jLabelmostrarfoto = new javax.swing.JLabel();
        jButtonNuevo = new javax.swing.JButton();
        jLabelRuta = new javax.swing.JLabel();
        jButtonModificar = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();
        jButtonSalir = new javax.swing.JButton();

        jMenuItemModificar.setText("Modificar");
        jMenuItemModificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemModificarActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItemModificar);

        jMenuItemEliminar.setText("Eliminar");
        jPopupMenu1.add(jMenuItemEliminar);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTableListado.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTableListado.setComponentPopupMenu(jPopupMenu1);
        jScrollPane1.setViewportView(jTableListado);

        jLabel1.setText("Nombre de usuario");

        jLabel2.setText("Elegir foto");

        jButtonAbrir.setText("Abrir");
        jButtonAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAbrirActionPerformed(evt);
            }
        });

        jButtonNuevo.setText("NUEVO");
        jButtonNuevo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNuevoActionPerformed(evt);
            }
        });

        jButtonModificar.setText("MODIFICAR");

        jButtonCancelar.setText("CANCELAR");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        jButtonSalir.setText("SALIR");
        jButtonSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSalirActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jLabelmostrarfoto, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(38, 38, 38))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1)
                            .addComponent(jTextFieldNombreUsuario)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jButtonAbrir, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE))
                            .addComponent(jLabelRuta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonNuevo, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonModificar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSalir, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldNombreUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(jButtonAbrir))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelmostrarfoto, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButtonNuevo)
                        .addComponent(jButtonModificar)
                        .addComponent(jButtonCancelar)
                        .addComponent(jButtonSalir))
                    .addComponent(jLabelRuta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAbrirActionPerformed
        // TODO add your handling code here:
        //construimos la instancia, para que pueda trabajar con el directorio por defecto de windows (documentos)
        JFileChooser chooser = new JFileChooser();
        //Esta clase nos crea un filtro, en este caso para que se vean solo las imagenes
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
                "Archivos Imagen", "jpg", "gif", "png");
        //Luego se visualiza solo los filtros asignados
        chooser.setFileFilter(filter);
        //Declaramos una variable de tipo enterop y utilizamos el constructor showOpenDialog
        int returnVal = chooser.showOpenDialog(this);
        //Evaluamos si pulsamos en el boton abrir nos devuelve un valor y que se va almaenar en un variable entero
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //Mostramos el nombre del archivo seleccionado
//            jLabelnombre.setText(file.getName());
            //Lo imprimimos en una caja de texto para ver su ruta del archivo
            jLabelRuta.setText(String.valueOf(file));
            //necesitamos la ruta de nuestra imagen para capturar la imagen
            Image foto = getToolkit().getImage(jLabelRuta.getText());
            //Le damos dimension a nuestro label que tendra la imagen
            foto = foto.getScaledInstance(110, 110, Image.SCALE_DEFAULT);
//            //Imprimimos la imagen en el label
            jLabelmostrarfoto.setIcon(new ImageIcon(foto));

        }
    }//GEN-LAST:event_jButtonAbrirActionPerformed

    private void jButtonNuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNuevoActionPerformed
        // TODO add your handling code here:
        if (jButtonNuevo.getText().equals("NUEVO")) {
            jTextFieldNombreUsuario.requestFocus();
            jButtonNuevo.setText("GUARDAR");
            jButtonCancelar.setEnabled(true);
            LimpiarCampos();
            EstadoCampos(true);
            jButtonAbrir.setEnabled(true);
        } else {
            if (jLabelRuta.getText().trim().length() != 0 && jTextFieldNombreUsuario.getText().length() != 0) {
                Insertar();
                llenarTabla();
                LimpiarCampos();
                EstadoCampos(false);
                jButtonCancelar.setEnabled(false);
                jButtonNuevo.setText("NUEVO");
                JOptionPane.showMessageDialog(rootPane, "Se guardó satisfactoriamente");
            } else {
                JOptionPane.showMessageDialog(rootPane, "Ingresar los datos correctamente");
            }
        }
    }//GEN-LAST:event_jButtonNuevoActionPerformed

    private void jMenuItemModificarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemModificarActionPerformed
        // TODO add your handling code here:
        EstadoCampos(true);
        jButtonModificar.setEnabled(true);
        jButtonCancelar.setEnabled(true);
        int filamodificar = jTableListado.getSelectedRow();
        if (filamodificar >= 0) {
            AsignarCampos();
        } else {
            JOptionPane.showMessageDialog(rootPane, "Modificar...");
        }
    }//GEN-LAST:event_jMenuItemModificarActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        // TODO add your handling code here:
        EstadoCampos(false);
        LimpiarCampos();
        jButtonNuevo.setText("NUEVO");
        jButtonNuevo.setEnabled(true);
        jButtonModificar.setEnabled(false);
        jButtonCancelar.setEnabled(false);
        jButtonAbrir.setEnabled(false);
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    private void jButtonSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSalirActionPerformed
        // TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_jButtonSalirActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(bdimagen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(bdimagen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(bdimagen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(bdimagen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new bdimagen().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAbrir;
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JButton jButtonModificar;
    private javax.swing.JButton jButtonNuevo;
    private javax.swing.JButton jButtonSalir;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelRuta;
    private javax.swing.JLabel jLabelmostrarfoto;
    private javax.swing.JMenuItem jMenuItemEliminar;
    private javax.swing.JMenuItem jMenuItemModificar;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableListado;
    private javax.swing.JTextField jTextFieldNombreUsuario;
    // End of variables declaration//GEN-END:variables
}
